unit uColors;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  EditBtn, StdCtrls, IniFiles;

type

  { TfrmColors }

  TfrmColors = class(TForm)
    btnOk: TButton;
    btnCancel: TButton;
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    ini: TIniFile;
    sl: TStringList;
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmColors: TfrmColors;

implementation

uses uMain;

{ TfrmColors }

procedure TfrmColors.btnOkClick(Sender: TObject);
var cb: TColorButton; chb: TCheckBox; i, j, k: Integer;
begin
  if Assigned(ini) then
  begin
    for i := 0 to sl.Count-1 do
    begin
      k := 0;
      for j := 0 to ComponentCount-1 do
      begin
        if (Components[j] is TColorButton) then
        begin
          cb := TColorButton(Components[j]);
          if cb.Hint = sl[i]+'F' then
          begin
            ini.WriteInteger(sl[i], 'Foreground', cb.ButtonColor);
          end
          else if cb.Hint = sl[i]+'B' then
          begin
            ini.WriteInteger(sl[i], 'Background', cb.ButtonColor);
          end;
        end
        else if (Components[j] is TCheckBox) then
        begin
          chb := TCheckBox(Components[j]);
          if chb.Hint = sl[i]+'Bold' then
          begin
            if chb.Checked then
              k := k or $1;
          end
          else if chb.Hint = sl[i]+'Italic' then
          begin
            if chb.Checked then
              k := k or $2;
          end
          else if chb.Hint = sl[i]+'Underline' then
          begin
            if chb.Checked then
              k := k or $4;
          end
          else if chb.Hint = sl[i]+'Strikeout' then
          begin
            if chb.Checked then
              k := k or $8;
          end
        end;
      end;
      ini.WriteInteger(sl[i], 'Style', k);
    end;
    FreeAndNil(ini);
    FreeAndNil(sl);
    frmMain.SetLanguage(frmMain.Language);
  end;
  close;
end;

procedure TfrmColors.btnCancelClick(Sender: TObject);
begin
  if Assigned(ini) then
    FreeAndNil(ini);
  if Assigned(sl) then
    FreeAndNil(sl);
  close;
end;

procedure TfrmColors.FormShow(Sender: TObject);
var i, k: Integer;
begin
  for i := ComponentCount-1 downto 0 do
  begin
    if (Components[i] is TLabel) or (Components[i] is TColorButton) or (Components[i] is TCheckBox) then
      Components[i].Free;
  end;
  if Assigned(ini) then
    ini.Free;
  if Assigned(sl) then
    sl.Free;

  if not Assigned(frmMain.synMain.Highlighter) then
  begin
    ShowMessage('No active highlighter detected!');
  end else begin;
    try
      try
        sl := TStringList.Create;
        ini := TIniFile.Create(SettingsPath+frmMain.synMain.Highlighter.Name+'.inc');
      except
        on e: Exception do
        begin
          ShowMessage('Error opening file (but should exist!): '+e.Message);
          exit;
        end;
      end;
      Caption := 'Colors for '+frmMain.synMain.Highlighter.Name;
      ini.ReadSections(sl);
      for i := 0 to sl.Count-1 do
      begin
        with TLabel.Create(self) do
        begin
          Parent := self;
          Left := 20;
          Top := 50+35*i;
          Height := 30;
          AutoSize := true;
          Caption := sl[i];
        end;
        with TColorButton.Create(self) do
        begin
          parent := self;
          Left := 100;
          Top := 50+35*i;
          Height := 30;
          Width := 50;
          ButtonColor:=ini.ReadInteger(sl[i], 'Foreground', 0);
          Hint := sl[i]+'F';
          Caption:='FG';
        end;
        with TColorButton.Create(self) do
        begin
          parent := self;
          Left := 160;
          Top := 50+35*i;
          Height := 30;
          Width := 50;
          ButtonColor:=ini.ReadInteger(sl[i], 'Background', 0);
          Hint := sl[i]+'B';
          Caption := 'BG';
        end;
        k := ini.ReadInteger(sl[i], 'Style', 0);
        with TCheckBox.Create(self) do
        begin
          Parent := self;
          Left := 220;
          Top := 50+35*i;
          height := 30;
          AutoSize := true;
          Caption := 'Bold';
          checked := k and $1 <> 0;
          Hint := sl[i]+'Bold';
        end;
        with TCheckBox.Create(self) do
        begin
          Parent := self;
          Left := 280;
          Top := 50+35*i;
          height := 30;
          AutoSize := true;
          Caption := 'Italic';
          checked := k and $2 <> 0;
          Hint := sl[i]+'Italic';
        end;
        with TCheckBox.Create(self) do
        begin
          Parent := self;
          Left := 340;
          Top := 50+35*i;
          height := 30;
          AutoSize := true;
          Caption := 'Underl';
          checked := k and $4 <> 0;
          Hint := sl[i]+'Underline';
        end;
        with TCheckBox.Create(self) do
        begin
          Parent := self;
          Left := 400;
          Top := 50+35*i;
          height := 30;
          AutoSize := true;
          Caption := 'Strikeout';
          checked := k and $8 <> 0;
          Hint := sl[i]+'Strikeout';
        end;
      end;
    finally
    end;
  end;
end;

initialization
  {$I ucolors.lrs}

end.

