unit uInfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls;

type

  { TfrmInfo }

  TfrmInfo = class(TForm)
    Image1: TImage;
    Image2: TImage;
    StaticText1: TStaticText;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    FPlaying: Boolean;
    buttons: Array of TButton;
    cursorx, cursory: Integer;
    speed: Integer;
    procedure buttonMouseMove(Sender: TObject; shift: TShiftState; X,Y: Integer);
    procedure StopPlaying;
    procedure StartPlaying;

  public
    { public declarations }
  end; 

var
  frmInfo: TfrmInfo;

implementation

uses uMain;

{ TfrmInfo }

procedure TfrmInfo.Image1Click(Sender: TObject);
begin
  if FPlaying then
  begin
    StopPlaying;
    ShowMessage('you win ):');
  end else begin
    StartPlaying;
  end;
end;

procedure TfrmInfo.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if FPlaying then
  begin
    CursorX := Image1.Left + X;
    CursorY := Image1.Top + Y;
  end;
end;

procedure TfrmInfo.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if FPlaying then
  begin
    cursorX:=X;
    cursorY:=Y;
  end;
end;

procedure TfrmInfo.FormShow(Sender: TObject);
begin

end;

procedure TfrmInfo.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  StopPlaying;
end;

procedure TfrmInfo.FormCreate(Sender: TObject);
begin
  StaticText1.Caption := TitleCaption + StaticText1.Caption;
end;

procedure TfrmInfo.Timer1Timer(Sender: TObject);
var i: Integer;
begin
  if ((CursorX > Image1.Left-30) and (CursorX < Image1.Left + Image1.Width+30)) and ((CursorY > Image1.Top-30) and (CursorY < Image1.Top+Image1.Height+30)) then
  begin
    Image1.Left := Random(Width)-Image1.Width;
    Image1.Top := Random(Height)-Image1.Height;
  end;

  if Random(40)=32 then
  begin
    speed := speed + 2;
    SetLength(Buttons, length(buttons)+1);
    buttons[high(buttons)] := TButton.Create(self);
    with buttons[high(buttons)] do
    begin
      left := Image1.Left;
      top := image1.Top;
      width := Image1.Width;
      height := image1.height;
      parent := self;
      caption := 'BOMB';
      OnMouseMove:=@buttonMouseMove;
    end;
  end;
  for i := 0 to Length(Buttons)-1 do
  begin
    if buttons[i].Left > cursorX then
      buttons[i].Left := buttons[i].Left - Speed;
    if buttons[i].Left < cursorX then
      buttons[i].Left := buttons[i].Left + speed;
    if buttons[i].Top > cursorY then
      buttons[i].Top := buttons[i].Top - speed;
    if buttons[i].Top < cursorY then
      buttons[i].Top := buttons[i].Top + speed;
  end;
end;

procedure TfrmInfo.buttonMouseMove(Sender: TObject; shift: TShiftState; X, Y: Integer);
begin
  StopPlaying;
  ShowMessage('Looooooooooser!');
end;

procedure TfrmInfo.StopPlaying;
var i: Integer;
begin
  FPlaying := false;
  Image1.Left := 16;
  Image1.Top := 16;
  for i := 0 to length(buttons)-1 do
  begin
    buttons[i].Free;
  end;
  setlength(buttons, 0);
  StaticText1.Visible := true;
  Image2.Visible:=true;
  Timer1.Enabled := false;
end;

procedure TfrmInfo.StartPlaying;
begin
  FPlaying := true;
  ShowMessage('Catch me!');
  speed := 3;
  StaticText1.Visible := false;
  Image2.Visible:=false;
  Image1.Left := Random(Width)-Image1.Width;
  Image1.Top := Random(Height)-Image1.Height;
  Timer1.Enabled := true;
end;

initialization
  {$I uinfo.lrs}

end.

