unit uProcess;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ProcessLineTalk, Process, ExtCtrls, LCLType;

type

  { TfrmProcess }

  TfrmProcess = class(TForm)
    btnClose: TButton;
    mmProcess: TMemo;
    Panel1: TPanel;
    procedure btnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
    FCommand: String;
    FWorkDir: String;
    FProcess: TProcessLineTalk;
    FOutput: Boolean;

    FDebug: Boolean;
    FDebugBin: String;
  public
    { public declarations }
    procedure Run;
    property Command: String read FCommand write FCommand;
    property WorkDir: String read FWorkDir write FWorkDir;
    property DebugBin: String read FDebugBin write FDebugBin;
    property Debug: Boolean read FDebug write FDebug;
    property Output: Boolean read FOutput write FOutput;
  end; 

var
  frmProcess: TfrmProcess;

implementation

uses umain;

{ TfrmProcess }

procedure TfrmProcess.FormShow(Sender: TObject);
begin
  Caption := 'Running '+FCommand;
  Run;
end;

procedure TfrmProcess.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  CloseAction := caFree;
  if Assigned(FProcess) then
  begin
    if FProcess.Running then
      FProcess.Terminate(1);
    FProcess.Free;
  end;
end;

procedure TfrmProcess.btnCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmProcess.Run;
var
  s: String;
  i: Integer;

begin
  FProcess := TProcessLineTalk.Create(nil);
  FProcess.CommandLine:=FCommand;
  FProcess.CurrentDirectory:=FWorkDir;
  FProcess.Options := FProcess.Options+ [poUsePipes];
  mmProcess.Lines.Add('<---Executing '+FCommand+'--->');

  if FDebug then
  begin
    FProcess.CommandLine:=FDebugBin+' -q -cd "'+FWorkDir+'"';
    for i := 0 to frmMain.BreakPointCount-1 do
    begin
      FProcess.CommandLine := Fprocess.commandLine+ ' -ex "b '+ExtractFileName(frmMain.FileName)+':'+IntToStr(frmMain.GetBreakPoint(i))+'"';
    end;
    FProcess.CommandLine := Fprocess.commandLine+ ' -ex "run" '+FCommand;
  end;

  FProcess.Execute;

  while (Assigned(FProcess)) and (FProcess.Running) do
  begin
    if FOutput then
    begin
      repeat
        s := FProcess.ReadLine;
        if s <> '' then
        begin
          mmProcess.Lines.Add(s);
        end;
      until s = '';
    end;
    Application.ProcessMessages;
    sleep(100);
  end;
  repeat
    s := FProcess.ReadLine;
    if s <> '' then
      mmProcess.Lines.Add(s);
  until s = '';

  mmProcess.Lines.Add('<---Exiting--->');

  frmMain.ActualLine := -1;
  FreeAndNil(FProcess);
end;

initialization
  {$I uprocess.lrs}

end.

